routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();


Route::middleware('auth')->group(function () {
    $this->any('/', function () {
        return view('index');
    })->name('index');


    Route::prefix('users')->name('users.')->group(function () {
        $this->any('/create', 'UserController@create')->name('create');
    });

    Route::prefix('subjects')->name('subjects.')->group(function () {
        $this->get('/', 'SubjectController@view')->name('index');
        $this->any('/create', 'SubjectController@create')->name('create');
        $this->any('/{subject}', 'SubjectController@update')->name('update');
        $this->any('/delete/{subject}', 'SubjectController@delete')->name('delete');
    });

    Route::prefix('faculties')->name('faculties.')->group(function () {
        $this->get('/', 'GroupController@view')->name('index');
        $this->get('/{id}', 'GroupController@directions')->name('direction');
        $this->get('/direction/{id}', 'GroupController@groups')->name('group');
        $this->get('/direction/group/{id}', 'GroupController@students')->name('student');
    });

    Route::prefix('plans')->name('plans.')->group(function () {
        $this->get('/', 'PlanController@semesters')->name('semesters');
        $this->get('/{semester}', 'PlanController@semester')->name('semester');
        $this->any('/{semester}/{group}', 'PlanController@group')->name('group');
    });
    Route::prefix('schedule')->name('schedule.')->group(function () {
        $this->get('/', 'LessonController@index')->name('index');
        $this->any('/{group}', 'LessonController@group')->name('group');
        $this->any('/prevWeek/{group}', 'LessonController@prevWeek')->name('prevWeek');
        $this->any('/add/{group}/{pair}/{day}', 'LessonController@add')->name('add');
        $this->any('/update/{lesson}/{day}', 'LessonController@update')->name('update');
    });

    Route::prefix('knowledge')->name('knowledge.')->group(function () {
        $this->get('/', 'KnowledgeController@index')->name('index');
        $this->post('/add', 'KnowledgeController@add')->name('add');
    });

});

app/Subject.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Subject extends Model {
    use SoftDeletes;

    protected $guarded = ['id'];

    public function teachers () {
        return $this->belongsToMany(Teacher::class, 'subjects2teachers');
    }

    public function directions () {
        return $this->belongsToMany(Direction::class, 'subjects2directions');
    }

    public function groups () {
        $query = $this->belongsToMany(Group::class, 'groups2subjects2semesters');

        if(isset($this->pivot)) {
            $query = $query->where(function ($q) {
                $q->where('groups2subjects2semesters.semester_id', $this->pivot->semester_id);
            });
        }

        return $query;
    }

    public function semesters () {
        $query = $this->belongsToMany(Semester::class, 'groups2subjects2semesters');

        if(isset($this->pivot)) {
            $query = $query->where(function ($q) {
                $q->where('groups2subjects2semesters.group_id', $this->pivot->group_id);
            });
        }

        return $query;
    }

    public function lessons () {
        $this->hasMany(Lesson::class);
    }


    public function knowledge () {
        return $this->hasMany(Knowledge::class);
    }
}

app/Http/Controllers/SubjectController.php
<?php

namespace App\Http\Controllers;

use App\Direction;
use App\Lesson;
use App\Subject;
use App\Teacher;
use Illuminate\Http\Request;
use phpDocumentor\Reflection\Types\Integer;

class SubjectController extends Controller
{
    public function view()
    {
        $subjects = Subject::all();

        return view('subjects.index', compact(['subjects']));
    }

    public function create(Request $request)
    {
        if ($request->isMethod('post')) {

            $subject = new Subject();

            $this->validate($request, [
                'name' => 'required',
            ]);

            $subject->name = $request->name;

            $subject->save();

            return redirect()->route('subjects.index');
        }

        return view('subjects.create');
    }

    public function update(Request $request, Subject $subject)
    {
        $teachers = Teacher::all();
        $directions = Direction::all();


        if ($request->isMethod('post')) {

            $this->validate($request, [
                'name' => 'required',
            ]);

            $subject->name = $request->name;

            $subject->save();

            $subject->teachers()->sync($request->teachers);

            $subject->directions()->sync($request->directions);

            return redirect()->route('subjects.index', compact(['teachers', 'directions']));
        }


        return view('subjects.update', compact(['subject', 'teachers', 'directions']));
    }

    public function delete(Subject $subject)
    {
        $subject->delete();


//        where(['id' => $subject->id])->delete();

        return redirect()->route('subjects.index');
    }
}

resources/views/subjects/create.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">
        <h2>Добавление предмета</h2>
        <form method="POST">
            @csrf

            <div class="form-group">
                <label for="name">Название предмета</label>
                <input type="text" name="name" class="form-control" id="name" placeholder="Введите название предмета"
                       value="{{ old('name') }}" required>
            </div>

            <button type="submit" class="btn btn-primary">Добавить</button>
        </form>
    </div>

@endsection

resources/views/subjects/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">
        <div class="d-flex flex-row justify-content-between w-100 align-items-center">
            <h2>Список предметов</h2>
            <a href="{{ route('subjects.create') }}" class="btn btn-sm btn-primary">Добавить предмет</a>
        </div>
        <div class="row">
            @foreach($subjects as $subject)
                <div class="col-4">
                    <a href="{{ route('subjects.update', ['$subject' => $subject]) }}">{{ $subject->name }}</a>
                </div>
            @endforeach
        </div>
    </div>

@endsection

resources/views/subjects/update.blade.php
@extends('layouts.app')

@section('content')



    <div class="container">
        <h2>{{ $subject->name }}</h2>
        <form method="POST">
            @csrf

            <div class="form-group">
                <label for="name">Название предмета</label>
                <input type="text" name="name" class="form-control" id="name" placeholder="Введите название предмета"
                       value="{{ $subject->name }}" required>
            </div>
            <h4>Список преподавалетелей</h4>
            <div class="row mb-5">
                @foreach($teachers as $teacher)
                    <div class="col-4">
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" value="{{ $teacher->id }}"
                                   id="teacher_{{ $teacher->id }}" name="teachers[]" {{ $subject->teachers->where('id', $teacher->id)->first() ? 'checked' : '' }}>
                            <label class="form-check-label" for="teacher_{{ $teacher->id }}">
                                {{ $teacher->second_name }}
                                {{ $teacher->middle_name }}
                                {{ $teacher->first_name }}
                            </label>
                        </div>
                    </div>
                @endforeach
            </div><h4>Список направлений</h4>
            <div class="row mb-5">
                @foreach($directions as $direction)
                    <div class="col-4">
                        <div class="form-check">
                            <input class="form-check-input" type="checkbox" value="{{ $direction->id }}"
                                   id="direction_{{ $direction->id }}" name="directions[]" {{ $subject->directions->where('id', $direction->id)->first() ? 'checked' : '' }}>
                            <label class="form-check-label" for="direction_{{ $direction->id }}">
                                {{ $direction->name }}
                            </label>
                        </div>
                    </div>
                @endforeach
            </div>


            <button type="submit" class="btn btn-primary">Сохранить</button>
            <a href="{{ route('subjects.delete', ['subject' => $subject]) }}" class="btn btn-danger">Удалить</a>
        </form>
    </div>

@endsection